; Grim Fandango Launcher
; Disable Hardware Acceleration and run the game
; Last Updated: 19 April 2009

#Persistent
#SingleInstance force
#NoEnv
;#NoTrayIcon

SendMode, Input
SetTitleMatchMode 2	; partial title match 
DetectHiddenWindows On

appname=Grim DirectDraw Fix

GoSub ReadINI
IniRead, filetolaunch, %A_ScriptDir%\%ScriptName%.ini, Settings, filetolaunch
IfNotExist,%filetolaunch%
  {
  MsgBox, 48, %appname%, The default Grim Fandango folder can not be located.`nIf you had installed in a custom folder, please select `nthe exe file from the ensuing dialog box.
  FileSelectFile, grimexe, 3, C:\Program Files\LucasArts\Grim\GrimFandango.exe, Select GRIM exe file, Executables (*.exe)
  If grimexe =
    {
    MsgBox, 64, %appname%, No selection was made. The program will now exit.
    ExitApp
    }
  Else
    {
    IniWrite, %grimexe%, %A_ScriptDir%\%ScriptName%.ini, Settings, filetolaunch
    IniRead, filetolaunch, %A_ScriptDir%\%ScriptName%.ini, Settings, filetolaunch
    GoSub, RunGrim
    }
  }
Else
  {
    GoSub, RunGrim
  }
Return

RunGrim:
Menu, tray, Icon, %filetolaunch%
SplitPath, filetolaunch,,OutDir

RegRead, Software, HKLM, SOFTWARE\Microsoft\Direct3D\Drivers, SoftwareOnly
RegRead, Emulation, HKLM, SOFTWARE\Microsoft\DirectDraw, EmulationOnly

If Software = 0
  RegWrite, REG_DWORD, HKLM, SOFTWARE\Microsoft\Direct3D\Drivers, SoftwareOnly, 1
If Emulation = 0
  RegWrite, REG_DWORD, HKLM, SOFTWARE\Microsoft\DirectDraw, EmulationOnly, 1

RunWait, %filetolaunch%, %OutDir%, UseErrorLevel
;reset directx settings and exit app
RegWrite, REG_DWORD, HKLM, SOFTWARE\Microsoft\Direct3D\Drivers, SoftwareOnly, 0
RegWrite, REG_DWORD, HKLM, SOFTWARE\Microsoft\DirectDraw, EmulationOnly, 0  

TrayTip, %appname%, Enabling DirectDraw Acceleration and exiting,,1
Sleep, 15000
ExitApp
Return

ReadINI:
;Write default path to GrimFandango.EXE
SplitPath, A_ScriptFullPath,,,, ScriptName
IfNotExist,%ScriptName%.ini
{
ini=
(
[Settings]
;Point to the grim exe file (default path)
filetolaunch=C:\Program Files\LucasArts\Grim\GrimFandango.exe
)
FileAppend,%ini%,%ScriptName%.ini
ini=
}
Return
